variables:
  MAJOR: 3
  MAX_IMAGE_SIZE_BYTE: 73400320
  MAX_SCAN_DURATION_SECONDS: 51
  GIT_SUBMODULE_STRATEGY: 'recursive'

include:
  - https://gitlab.com/gitlab-org/security-products/ci-templates/raw/master/includes-dev/analyzer.yml

check image size:
  image: docker:stable
  services:
    - name: docker:stable-dind
  script:
    - export PATH=$PATH:$HOME/go/bin
    - apk add go git
    - go get -v github.com/wagoodman/dive
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker pull $TMP_IMAGE
    - IMAGE_NAME="${TMP_IMAGE}" /bin/sh ./script/test image
  needs: ['build tmp image']

build tmp image:
  image: docker:stable
  needs: []
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - apk add go git curl
  script:
    - IMAGE_NAME="${TMP_IMAGE}" ./script/build
    - docker push $TMP_IMAGE

integration test:
  stage: test
  image: docker:stable
  services:
    - name: "registry.gitlab.com/gitlab-org/security-products/analyzers/clair-vulnerabilities-db:latest"
      alias: clair-vulnerabilities-db
    - name: docker:stable-dind
  needs: []
  script:
    - ./script/setup
    - ./script/build pkg
    - ./script/test integration --format RspecJunitFormatter --out rspec.xml
    - echo '1' > analyzer_scan_duration_in_seconds.txt
  rules:
    - when: always
  artifacts:
    expire_in: 1 week
    paths:
      - rspec.xml
      - analyzer_scan_duration_in_seconds.txt
    reports:
      junit: rspec.xml
  tags:
    - fips

go lint:
  script:
    - apt-get update -y
    - apt-get install -y --no-install-recommends shellcheck
    - ./script/test lint

container-scanning-qa:
  extends: .qa-downstream-cs
  trigger:
    project: gitlab-org/security-products/tests/container-scanning
